LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY tp1_ex2_msa_tb IS
END tp1_ex2_msa_tb;
 
ARCHITECTURE behavior OF tp1_ex2_msa_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT msa_tp1_ex2
      Port(
        clk_i : in  STD_LOGIC;
        rst_i : in  STD_LOGIC;
        bouton_left_i : in  STD_LOGIC;
        bouton_up_i : in  STD_LOGIC;
        bouton_center_i : in  STD_LOGIC;
        bouton_right_i : in STD_LOGIC;
        bouton_down_i : in STD_LOGIC;
        dels_o : out std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal pb_left_tb : std_logic := '0';
   signal pb_up_tb : std_logic := '0';
   signal pb_center_tb : std_logic := '0';
   signal pb_right_tb : std_logic := '0';
   signal pb_down_tb : std_logic := '0';
   signal clk_tb : std_logic := '0';
   signal rst_tb : std_logic;

 	--Outputs
	signal dels_tb : std_logic_vector(7 downto 0);

   -- Clock period definitions
   constant clk_period : time := 5 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
    uut: msa_tp1_ex2 
        port map
          (
          clk_i => clk_tb,
          rst_i => rst_tb,
          bouton_left_i => pb_left_tb,
          bouton_up_i => pb_up_tb,
          bouton_center_i => pb_center_tb,
          bouton_right_i => pb_right_tb,
          bouton_down_i => pb_down_tb,
          dels_o => dels_tb --directement relie aux DELs
          ); 

   -- Clock process definitions
   clk_process :process
   begin
		clk_tb <= '0';
		wait for clk_period/2;
		clk_tb <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      rst_tb <= '1';


		wait for clk_period*10 ;            --exemples de stimuli
		rst_tb <= '0';
		
      wait for clk_period*10;

		pb_up_tb <= '1';
		
		wait for clk_period*10;

		pb_up_tb <= '0';

      wait for clk_period*10;
		
		pb_left_tb <= '1';
		pb_center_tb <= '1';
		
	  wait for clk_period*10;
	  
	    pb_left_tb <= '0';
        pb_center_tb <= '0';
	  
      wait for clk_period*10;
              
        pb_up_tb <= '1';
       
      wait for clk_period*10;
                      
        pb_up_tb <= '0';          
      wait;
   end process;

END;
