LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY tp1_ex2_tb IS
END tp1_ex2_tb;
 
ARCHITECTURE behavior OF tp1_ex2_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT tp1_ex2_top
      Port ( 
        rst_i_n : in std_logic;
        clk_100mhz_i : in std_logic;
        btnc : in std_logic;
        btnd: in std_logic;
        btnl : in std_logic;
        btnr: in std_logic;
        btnu : in std_logic;
        dels_o: out std_logic_vector(7 downto 0)
    );
    END COMPONENT;
    

   --Inputs
   signal pb_left_tb : std_logic := '0';
   signal pb_up_tb : std_logic := '0';
   signal pb_center_tb : std_logic := '0';
   signal pb_right_tb : std_logic := '0';
   signal pb_down_tb : std_logic := '0';
   signal clk_100mhz_tb : std_logic := '0';
   signal rst_n_tb : std_logic;

 	--Outputs
	signal dels_tb : std_logic_vector(7 downto 0);

   -- Clock period definitions
   constant clk_period : time := 5 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: tp1_ex2_top PORT MAP (
          rst_i_n => rst_n_tb,
            clk_100mhz_i => clk_100mhz_tb,
            btnl => pb_left_tb,
            btnu => pb_up_tb,
            btnc => pb_center_tb,
            btnr => pb_right_tb,
            btnd => pb_down_tb,
            dels_o => dels_tb
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk_100mhz_tb <= '0';
		wait for clk_period/2;
		clk_100mhz_tb <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      rst_n_tb <= '0';          --reset en logique inverse


		wait for clk_period*100000 ;            --exemples de stimuli
		rst_n_tb <= '1';
		
      wait for clk_period*100000;

		pb_up_tb <= '1';
		
		wait for clk_period*100000;

		pb_up_tb <= '0';

      wait for clk_period*100000;
		
		pb_left_tb <= '1';
		pb_center_tb <= '1';
		
	  wait for clk_period*100000;
	  
	    pb_left_tb <= '0';
        pb_center_tb <= '0';
	  
      wait for clk_period*100000;
              
        pb_up_tb <= '1';
       
      wait for clk_period*100000;
                      
        pb_up_tb <= '0';          
      wait;
   end process;

END;
