

----------------------------------------------------------------------------------
-- Author: SIMARD Virginie
-- 
-- Create Date:    17:52:55 05/10/2012 
-- Design Name: 
-- Module Name:    div_clk_500 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: divides input clock by 500
--
-- Dependencies: None
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--                       
--                       
----------------------------------------------------------------------------------


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.Numeric_std.ALL;


entity divise_clk_2000 is	
    Port ( 
        rst_i : in std_logic;
        clk_i : in std_logic;
        clk_o: out std_logic
    );
end divise_clk_2000;

architecture arch_divise_clk_2000 of divise_clk_2000 is


signal cntdiv_p, cntdiv_f : std_logic_vector (11 downto 0);
signal div_temp_p, div_temp_f : std_logic;


begin
clk_o <= div_temp_p;
 
P_sync: process (clk_i, rst_i)
begin
    if rst_i='1' then
        div_temp_p <= '0';
        cntdiv_p <= (others => '0');
    elsif (clk_i'event and clk_i = '1') then
        div_temp_p <= div_temp_f;
		 cntdiv_p <= cntdiv_f;
    end if;
end process;

P_comb: process(cntdiv_p, div_temp_p)
begin
    if unsigned(cntdiv_p) >= 1000 then -- Diviseur par 2000
        div_temp_f <= not(div_temp_p);
        cntdiv_f <= (others => '0');
    else
        div_temp_f <= div_temp_p;
        cntdiv_f <= std_logic_vector(unsigned(cntdiv_p) + 1);
    end if;
end process;

end arch_divise_clk_2000;

